/*
 * KawuiBawuiBo Game:
 *   - Copyright(c) 2000 Yongwoo's Park. All Rights Reserved.
 */

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.Date;
import java.util.Vector;
import java.util.StringTokenizer;

public class ClientLobby extends Applet implements Runnable {
   Thread clientLobbyThread = null;
   private AppletContext appletContext = null;

   static String KAWUI_BAWUI_BO_GAME_SERVER;
   final static int KAWUI_BAWUI_BO_GAME_PORT=4001;

   public Socket socket=null;
   public BufferedReader is=null;
   public PrintWriter os=null;

   String roomId=null, playerId=null;

   Image backgroundImage=null;
   ImageCanvas backgroundCanvas=null;

   List roomList=null;
   List playerList=null;
   TextArea chatArea=null;
   TextField chatField=null;

   Button makeRoomButton=null;
   Button joinRoomButton=null;
   Button exitButton=null;

   CardLayout kawuiBawuiBoCardLayout=null;
   Panel cardPanel=null;
   Panel lobbyPanel=null;
   ClientRoom boardPanel=null;

   public void init() {
      KAWUI_BAWUI_BO_GAME_SERVER = getCodeBase().getHost();

      kawuiBawuiBoCardLayout = new CardLayout();
      cardPanel = new Panel(kawuiBawuiBoCardLayout);

      lobbyPanel = initLobbyPanel();
      boardPanel = new ClientRoom(ClientLobby.this);

      connect();

      cardPanel.add(lobbyPanel, "LobbyPanel");
      cardPanel.add(boardPanel, "BoardPanel");

      setLayout(new BorderLayout());
      add("Center", cardPanel);

      kawuiBawuiBoCardLayout.show(cardPanel, "LobbyPanel");
   }

   public Panel initLobbyPanel() {
      lobbyPanel = new Panel(null);

      MediaTracker mwTrack = new MediaTracker(this);

      backgroundImage = getImage(getDocumentBase(), "images/LobbyBackground.jpg");
      mwTrack.addImage(backgroundImage, 0);

      try {
         mwTrack.waitForAll();
      } catch(InterruptedException e) {
      }

      backgroundCanvas = new ImageCanvas(backgroundImage,
                                         lobbyPanel, 776, 585);
      backgroundCanvas.setBounds(0, 0, 776, 585);

      roomList = new List();
      playerList = new List();
      chatArea = new TextArea();
      chatArea.setEditable(false);
      chatField = new TextField();

      roomList.setBounds(14, 145, 537, 212);
      playerList.setBounds(568, 145, 202, 212);
      chatArea.setBounds(80, 389, 690, 101);
      chatField.setBounds(14, 502, 756, 26);

      makeRoomButton = new Button("游");
      joinRoomButton = new Button("");
      exitButton = new Button("");

      makeRoomButton.setBounds(189, 541, 60, 21);
      joinRoomButton.setBounds(253, 541, 60, 21);
      exitButton.setBounds(317, 541, 60, 21);

      lobbyPanel.add(roomList);
      lobbyPanel.add(playerList);
      lobbyPanel.add(chatArea);
      lobbyPanel.add(chatField);
      lobbyPanel.add(makeRoomButton);
      lobbyPanel.add(joinRoomButton);
      lobbyPanel.add(exitButton);
      lobbyPanel.add(backgroundCanvas);

      ActionListener al = new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            if(e.getSource() == chatField) {
               String chatStr = chatField.getText();
               String message = "100|BROADCAST|"+playerId+"|*|"+chatStr;
               chatField.setText("");

               sendToServer(message);
            } else if(e.getSource() == makeRoomButton) {
               makeRoomButton.setEnabled(false);
               joinRoomButton.setEnabled(false);
               exitButton.setEnabled(false);

               TextDialog s = new TextDialog((Frame)(ClientLobby.this.getParent()),
                                             " ...",
                                             " ̸ Էϼ...");

               s.show();

               roomId = s.field.getText().trim();
               if(!"".equals(roomId)) {
                  boolean existFlag = false;
                  String items[] = roomList.getItems();
                  for(int i=0;i<items.length;i++) {
                     if(items[i].trim().equals(roomId)) {
                        existFlag = true;
                        break;
                     }
                  }
                  if(existFlag == false) {
                     sendToServer("120|"+playerId+"|"+roomId);
                     boardPanel.initComponent();

                     enterRoom(playerId, roomId);
                  } else {
                     WarningDialog w = new WarningDialog((Frame)(ClientLobby.this.getParent()),
                                                         "Warning",
                                                         "̸ ߺǾϴ.");
                     w.show();
                  }
               }
               buttonDefaultSetting();
            } else if((e.getSource() == joinRoomButton)||(e.getSource() == roomList)) {
               String selectedRoom = roomList.getSelectedItem();
               if((selectedRoom != null)&&(!"".equals(selectedRoom))&&(!"".equals(selectedRoom))) {
                  enterRoom(playerId, selectedRoom);
               }
            } else if(e.getSource() == exitButton) {
               sendToServer("182|LEAVE|"+playerId);
               try {
                  String setRestartURLString = "http://"+getDocumentBase().getHost()+"/finish.asp?id="+playerId;
                  URL setRestartURL = new URL(setRestartURLString);
                  getAppletContext().showDocument(setRestartURL);
               } catch(MalformedURLException ee) {
               }
            } else if(e.getSource() == roomList) {
            }
         }
      };

      chatField.addActionListener(al);
      makeRoomButton.addActionListener(al);
      joinRoomButton.addActionListener(al);
      exitButton.addActionListener(al);
      roomList.addActionListener(al);

      roomList.addItemListener(new ItemListener() {
         public void itemStateChanged(ItemEvent e) {
            if(e.getStateChange() == ItemEvent.SELECTED) {
               String selectedRoom = roomList.getSelectedItem();
               if(selectedRoom != null && !"".equals(selectedRoom)) {
                  sendToServer("112|"+playerId+"|"+selectedRoom);
                  if("".equals(selectedRoom)) {
                     joinRoomButton.setEnabled(false);
                  } else {
                     joinRoomButton.setEnabled(true);
                  }
               }
            }
         }
      });

      FocusListener fl = new FocusAdapter() {
         public void focusGained(FocusEvent e) {
            chatField.requestFocus();
         }
      };

      roomList.addFocusListener(fl);
      playerList.addFocusListener(fl);
      chatArea.addFocusListener(fl);

      chatField.requestFocus();

      return(lobbyPanel);
   }

   public void buttonDefaultSetting() {
      makeRoomButton.setEnabled(true);
      String selectedRoom = roomList.getSelectedItem();
      if(selectedRoom != null && !"".equals(selectedRoom)) {
         if(!"".equals(selectedRoom)) {
            joinRoomButton.setEnabled(true);
         } else {
            joinRoomButton.setEnabled(false);
         }
      } else {
         joinRoomButton.setEnabled(false);
      }
      exitButton.setEnabled(true);
   }

   private void connect() {
//      playerId = getParameter("id");
      playerId = ""+new Date().getTime();

      try {
         socket = new Socket(KAWUI_BAWUI_BO_GAME_SERVER, KAWUI_BAWUI_BO_GAME_PORT);
         is = new BufferedReader(new InputStreamReader(socket.getInputStream()));
         os = new PrintWriter(socket.getOutputStream(), true);

         String receive=null;
         StringTokenizer st = null;
         String command = null;
         try {
            receive = receiveMessage();  // "UserName" is read
            sendToServer(playerId);

            socket.setSoTimeout(10);   // ʹ 10ms  ٸ , ޽ Ȯ ..
         } catch(Exception e) { //Unknown error. Throw tantrum.
            chatArea.append("ܹ߻: "+e+"\n");
         }
      } catch(UnknownHostException e) {
         chatArea.append("ܹ߻: "+e+"\n");
         stop();
         return;
      } catch(SocketException e) {
         chatArea.append("ܹ߻: "+e+"\n");
         stop();
         return;
      } catch(IOException e) {
         chatArea.append("ܹ߻: "+e+"\n");
         stop();
         return;
      }
   }

   public synchronized void start() {
      if(clientLobbyThread == null) {
         try {
            if(socket != null) {
               if(is == null) {
                  is = new BufferedReader(new InputStreamReader(socket.getInputStream()));
               }
               if(os == null) {
                  os = new PrintWriter(socket.getOutputStream(), true);
               }
            } else {
               connect();
            }
            clientLobbyThread = new Thread(this);
            clientLobbyThread.start();
         } catch(IOException e) {
         }
      }
   }

   public synchronized void stop() {
      if(clientLobbyThread != null) {
         clientLobbyThread.stop();
         clientLobbyThread = null;
      }
   }

   public synchronized void destroy() {
      try {
         if(is != null) {
            is.close();
            is = null;
         }
      } catch(Exception e) {
         System.out.println(e);
      }
      try {
         if(os != null) {
            os.close();
            os = null;
         }
      } catch(Exception e) {
         System.out.println(e);
      }
      try {
         if(socket != null) {
            socket.close();
            socket = null;
         }
      } catch(Exception e) {
         System.out.println(e);
      }
   }

   public void sendToServer(String message) {
      if(message != null) {
         os.println(message);
         os.flush();

         if(os.checkError()) {
         }
         System.out.println("Send: "+message);
      }
   }

   public String receiveMessage() throws SocketException {
      String message = null;
      try {
         message = is.readLine();
         System.out.println("Receive: "+message);
      } catch(SocketException e) {
         throw(e);
      } catch(Exception e) {
         return "";
      }
      return message;
   }

   public void messageBoard(String message) {
      chatArea.append("\n[޽] "+message+"\n\n");
   }

   public void updateRoomList(String roomIds) {
      if(roomIds == null) {
         return;
      }
      StringTokenizer st = new StringTokenizer(roomIds, ",");
      String selectedRoomId = roomList.getSelectedItem();
      roomList.removeAll();
      int i= 0;
      boolean flag=false;
      while(st.hasMoreTokens()) {
         String roomId = st.nextToken();
         roomList.add(roomId);
         if(roomId.equals(selectedRoomId)) {
            roomList.select(i);
            flag = true;
         }
         i++;
      }
      if(flag = false) {
         roomList.select(0);
         sendToServer("112|"+playerId+"|"+roomList.getItem(0));
      }
   }

   public void updateUserList(String roomId, String playerIds) {
      if((roomId == null)||(playerIds == null)) {
         return;
      }
      if(roomId.equals(roomList.getSelectedItem())) {
         StringTokenizer st = new StringTokenizer(playerIds, ",");
         playerList.removeAll();
         while(st.hasMoreTokens()) {
            playerList.add(st.nextToken());
         }
      }
   }

   public void enterRoom(String playerId, String roomId) {
      sendToServer("122|"+playerId+"|"+roomId);

      kawuiBawuiBoCardLayout.show(cardPanel, "BoardPanel");

      sendToServer("580|JOIN_ROOM|"+playerId);
   }

   public void run() {
      String receive=null;
      while(Thread.currentThread() == clientLobbyThread) {
         try {
            Thread.sleep(100);
         } catch(InterruptedException e) {
         }
         try {
            receive = receiveMessage();
            if((receive == null)||("".equals(receive))) {
               continue;
            }
            processMessage(receive);
            boardPanel.processMessage(receive);
         } catch(SocketException e) { //Stream doesn't exist.
            stop();
            return;
         } catch(Exception e) { //Unknown error. Throw tantrum.
         }
      }
   }

   public void processMessage(String receive) {
      StringTokenizer st = new StringTokenizer(receive, "|");
      String command = st.nextToken();
      if("300".equals(command)) {         // εĳ ä
         // εĳ ä  300|BROADCAST|playerId|*|chatStr
         String type = st.nextToken();
         String playerId = st.nextToken();
         String target = st.nextToken();
         String chatStr = st.nextToken();

         chatArea.append(chatStr+"\n");
      } else if("302".equals(command)) {         // εĳ ä
         // εĳ ä  302|GROUPCAST|playerId|groupId|chatStr
         String type = st.nextToken();
         String playerId = st.nextToken();
         String groupId = st.nextToken();
         String chatStr = st.nextToken();

         chatArea.append(chatStr+"\n");
      } else if("304".equals(command)) {         // εĳ ä
         // εĳ ä  304|UNICAST|playerId|toPlayerId|chatStr
         String type = st.nextToken();
         String fromPlayerId = st.nextToken();
         String toPlayerId = st.nextToken();
         String chatStr = st.nextToken();

         chatArea.append(chatStr+"\n");
      } else if("310".equals(command)) {
         // 븮Ʈ           310|playerId|roomId#1,roomId#2,,roomId#n
         String playerId = st.nextToken();
         String roomIds = st.nextToken();

         updateRoomList(roomIds);
      } else if("312".equals(command)) {
         // ڸƮ       312|playerId|roomId|playerId#1,playerId#2,,playerId#n
         String playerId = st.nextToken();
         String roomId = st.nextToken();
         String playerIds = st.nextToken();

         updateUserList(roomId, playerIds);
      } else if("320".equals(command)) {
         // 游       320|playerId|roomId|[SUCCESS|FAIL]
         String playerId = st.nextToken();
         String roomId = st.nextToken();
         String result = st.nextToken();

      } else if("322".equals(command)) {
         //          322|playerId|roomId|[SUCCESS|FULL|NOROOM]
         String playerId = st.nextToken();
         String roomId = st.nextToken();
         String result = st.nextToken();

         if("SUCCESS".equals(result)) {
            enterRoom(playerId, roomId);
         }
      } else if("380".equals(command)) {
         //            380|JOIN|playerId
         String type = st.nextToken();
         String playerId = st.nextToken();

      } else if("382".equals(command)) {
         //            382|LEAVE|playerId
         String type = st.nextToken();
         String playerId = st.nextToken();

      } else if("399".equals(command)) {
         // ޽         399|playerId|message
         String playerId = st.nextToken();
         String message = st.nextToken();

         messageBoard(message);
      }
   }
}
