/*
 * KawuiBawuiBo Game:
 *   - Copyright(c) 2000 Yongwoo's Park. All Rights Reserved.
 */

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.sql.*;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.StringTokenizer;

public class ClientRoom extends Panel {
   ClientLobby parentApplet=null;

   Image backgroundImage=null;
   ImageCanvas backgroundCanvas=null;

   ImageButton kawuiButton=null;
   ImageButton bawuiButton=null;
   ImageButton boButton=null;
   ImageButton exitButton=null;

   ImageCanvas kawuiCanvas=null;
   ImageCanvas bawuiCanvas=null;
   ImageCanvas boCanvas=null;

   Label playerId1Label=null;
   Label playerId2Label=null;
   Label pointLabel=null;

   List playerList=null;
   TextArea chatArea=null;
   TextField chatField=null;

   Image kawuiImage=null;
   Image bawuiImage=null;
   Image boImage=null;

   Image offImage=null;
   Graphics offGraphics=null;

   int myX=-1, yourX=-1;
   public ClientRoom(ClientLobby parentApplet) {
      this.parentApplet = parentApplet;
      init();
   }

   public void reset() {
      initGame();
      repaint();
   }

   public void initGame() {
   }

   public void initComponent() {
   }

   public void init(ClientLobby parentApplet) {
      this.parentApplet = parentApplet;
      init();
   }

   public void init() {
      setLayout(null);

      MediaTracker mwTrack = new MediaTracker(this);

      backgroundImage = parentApplet.getImage(parentApplet.getDocumentBase(), "images/RoomBackground.jpg");

      kawuiImage = parentApplet.getImage(parentApplet.getDocumentBase(), "images/Kawui.jpg");
      bawuiImage = parentApplet.getImage(parentApplet.getDocumentBase(), "images/Bawui.jpg");
      boImage = parentApplet.getImage(parentApplet.getDocumentBase(), "images/Bo.jpg");

      Image kawuiReleasedOffImage = parentApplet.getImage(parentApplet.getDocumentBase(), "images/KawuiReleasedOff.jpg");
      Image kawuiReleasedOnImage = parentApplet.getImage(parentApplet.getDocumentBase(), "images/KawuiReleasedOn.jpg");
      Image kawuiPressedImage = parentApplet.getImage(parentApplet.getDocumentBase(), "images/KawuiPressed.jpg");

      Image bawuiReleasedOffImage = parentApplet.getImage(parentApplet.getDocumentBase(), "images/BawuiReleasedOff.jpg");
      Image bawuiReleasedOnImage = parentApplet.getImage(parentApplet.getDocumentBase(), "images/BawuiReleasedOn.jpg");
      Image bawuiPressedImage = parentApplet.getImage(parentApplet.getDocumentBase(), "images/BawuiPressed.jpg");

      Image boReleasedOffImage = parentApplet.getImage(parentApplet.getDocumentBase(), "images/BoReleasedOff.jpg");
      Image boReleasedOnImage = parentApplet.getImage(parentApplet.getDocumentBase(), "images/BoReleasedOn.jpg");
      Image boPressedImage = parentApplet.getImage(parentApplet.getDocumentBase(), "images/BoPressed.jpg");

      Image exitReleasedOffImage = parentApplet.getImage(parentApplet.getDocumentBase(), "images/ExitReleasedOff.jpg");
      Image exitReleasedOnImage = parentApplet.getImage(parentApplet.getDocumentBase(), "images/ExitReleasedOn.jpg");
      Image exitPressedImage = parentApplet.getImage(parentApplet.getDocumentBase(), "images/ExitPressed.jpg");

      mwTrack.addImage(backgroundImage, 0);

      mwTrack.addImage(kawuiImage, 0);
      mwTrack.addImage(bawuiImage, 0);
      mwTrack.addImage(boImage, 0);

      mwTrack.addImage(kawuiReleasedOffImage, 0);
      mwTrack.addImage(kawuiReleasedOnImage, 0);
      mwTrack.addImage(kawuiPressedImage, 0);

      mwTrack.addImage(bawuiReleasedOffImage, 0);
      mwTrack.addImage(bawuiReleasedOnImage, 0);
      mwTrack.addImage(bawuiPressedImage, 0);

      mwTrack.addImage(boReleasedOffImage, 0);
      mwTrack.addImage(boReleasedOnImage, 0);
      mwTrack.addImage(boPressedImage, 0);

      mwTrack.addImage(exitReleasedOffImage, 0);
      mwTrack.addImage(exitReleasedOnImage, 0);
      mwTrack.addImage(exitPressedImage, 0);

      try {
         mwTrack.waitForAll();
      } catch(InterruptedException e) {
      }

//      backgroundCanvas = new ImageCanvas(backgroundImage, this, 776, 585);

      kawuiCanvas = new ImageCanvas(kawuiImage, this,
                                    kawuiImage.getWidth(this),
                                    kawuiImage.getHeight(this));
      bawuiCanvas = new ImageCanvas(bawuiImage, this,
                                    bawuiImage.getWidth(this),
                                    bawuiImage.getHeight(this));
      boCanvas = new ImageCanvas(boImage, this,
                                 boImage.getWidth(this),
                                 boImage.getHeight(this));

      playerId1Label = new Label(parentApplet.playerId, Label.CENTER);
      playerId2Label = new Label("", Label.CENTER);
      pointLabel = new Label("0:0", Label.CENTER);

      playerList = new List();
      chatArea = new TextArea();
      chatArea.setEditable(false);
      chatField = new TextField();

      kawuiButton = new ImageButton(kawuiReleasedOffImage, kawuiReleasedOnImage, kawuiPressedImage);
      bawuiButton = new ImageButton(bawuiReleasedOffImage, bawuiReleasedOnImage, bawuiPressedImage);
      boButton = new ImageButton(boReleasedOffImage, boReleasedOnImage, boPressedImage);
      exitButton = new ImageButton(exitReleasedOffImage, exitReleasedOnImage, exitPressedImage);
//      exitButton = new Button("");

//      backgroundCanvas.setBounds(0, 0, 776, 585);

      playerList.setBounds(568, 145, 202, 212);
      chatArea.setBounds(80, 389, 690, 101);
      chatField.setBounds(14, 502, 756, 26);

      playerId1Label.setBounds(110, 292, 100, 22);
      playerId2Label.setBounds(355, 292, 100, 22);
      pointLabel.setBounds(220, 316, 125, 22);

      kawuiButton.setBounds(275, 531, 55, 50);
      bawuiButton.setBounds(330, 531, 55, 50);
      boButton.setBounds(385, 531, 55, 50);
      exitButton.setBounds(440, 530, 55, 50);


      kawuiButton.setEnabled(false);
      bawuiButton.setEnabled(false);
      boButton.setEnabled(false);
      exitButton.setEnabled(true);

      add(playerId1Label);
      add(playerId2Label);
      add(pointLabel);

      add(playerList);
      add(chatArea);
      add(chatField);

      add(kawuiButton);
      add(bawuiButton);
      add(boButton);
      add(exitButton);

      ActionListener al = new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            String message=null;
            if(e.getSource() == chatField) {
               String chatStr = chatField.getText();
               if(!"".equals(chatStr)) {
                  message = "500|BROADCAST|"+parentApplet.playerId+"|*|"+chatStr;
                  sendToServer(message);
               }
               chatField.setText("");
            } else if(e.getSource() == kawuiButton) {
               message = "522|PUT|"+parentApplet.playerId+"|KAWUI";
               sendToServer(message);

               messageBoard(" ½ϴ.");

               setButtonEvent(false);
            } else if(e.getSource() == bawuiButton) {
               message = "522|PUT|"+parentApplet.playerId+"|BAWUI";
               sendToServer(message);
               messageBoard(" ½ϴ.");

               setButtonEvent(false);
            } else if(e.getSource() == boButton) {
               message = "522|PUT|"+parentApplet.playerId+"|BO";
               sendToServer(message);
               messageBoard(" ½ϴ.");

               setButtonEvent(false);
            } else if(e.getSource() == exitButton) {
               sendToServer("582|EXIT_ROOM|"+parentApplet.playerId);
               parentApplet.kawuiBawuiBoCardLayout.show(parentApplet.cardPanel, "LobbyPanel");
               parentApplet.buttonDefaultSetting();
            }
         }
      };

      chatField.addActionListener(al);

      kawuiButton.addActionListener(al);
      bawuiButton.addActionListener(al);
      boButton.addActionListener(al);
      exitButton.addActionListener(al);

      FocusListener fl = new FocusAdapter() {
         public void focusGained(FocusEvent e) {
            chatField.requestFocus();
         }
      };

      playerList.addFocusListener(fl);
      chatArea.addFocusListener(fl);

      chatField.requestFocus();

//      add(backgroundCanvas);

      offImage = parentApplet.createImage(parentApplet.getSize().width, parentApplet.getSize().height);
      offGraphics = offImage.getGraphics();
/*
      exitButton.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            parentApplet.kawuiBawuiBoCardLayout.show(parentApplet.cardPanel, "Lobbypanel");
         }
      });
*/
   }

   public void repaint() {
      paint(getGraphics());
   }

   public void update(Graphics g) {
      paint(g);
   }

   public void paint(Graphics g) {
      offGraphics.drawImage(backgroundImage, 0, 0, getSize().width, getSize().height, this);

      offGraphics.drawImage(kawuiImage, 110, 190, 100, 100, this);
      offGraphics.drawImage(bawuiImage, 355, 190, 100, 100, this);

      switch(myX) {
         case 0: offGraphics.drawImage(kawuiImage, 110, 190, 100, 100, this); break;
         case 1: offGraphics.drawImage(bawuiImage, 110, 190, 100, 100, this); break;
         case 2: offGraphics.drawImage(boImage, 110, 190, 100, 100, this); break;
         default:
            offGraphics.setColor(Color.lightGray);
            offGraphics.fillRect(110, 190, 100, 100);
         break;
      }
      switch(yourX) {
         case 0: offGraphics.drawImage(kawuiImage, 355, 190, 100, 100, this); break;
         case 1: offGraphics.drawImage(bawuiImage, 355, 190, 100, 100, this); break;
         case 2: offGraphics.drawImage(boImage, 355, 190, 100, 100, this); break;
         default:
            offGraphics.setColor(Color.lightGray);
            offGraphics.fillRect(355, 190, 100, 100);
         break;
      }

      g.drawImage(offImage, 0, 0, this);
   }

   public void messageBoard(String message) {
      chatArea.append("\n[޽] "+message+"\n\n");
   }

   public String receiveMessage() throws SocketException {
      try {
         return(parentApplet.receiveMessage());
      } catch(SocketException e) {
         throw(e);
      }
   }

   public void sendToServer(String message) {
      parentApplet.sendToServer(message);
   }

   public void setButtonEvent(boolean falg) {
      kawuiButton.setEnabled(falg);
      bawuiButton.setEnabled(falg);
      boButton.setEnabled(falg);
      exitButton.setEnabled(true);
   }

   public void startGame() {
      setButtonEvent(true);
   }

   public void finishGame() {
      setButtonEvent(false);
   }

   public void animatePut(String playerPae1, String playerPae2) {
      // X: 0-KaWui, 1-BaWui, 2-Bo
      Image images[] = new Image[3];

      if("KAWUI".equals(playerPae1)) {
         myX = 0;
      } else if("BAWUI".equals(playerPae1)) {
         myX = 1;
      } else if("BO".equals(playerPae1)) {
         myX = 2;
      }
      if("KAWUI".equals(playerPae2)) {
         yourX = 0;
      } else if("BAWUI".equals(playerPae2)) {
         yourX = 1;
      } else if("BO".equals(playerPae2)) {
         yourX = 2;
      }
      images[0] = kawuiImage;
      images[1] = bawuiImage;
      images[2] = boImage;

      Graphics g = getGraphics();
      for(int i=0;i<20;i++) {
         int rand = (int)(Math.random() * 3.0);

         g.drawImage(images[(rand+myX)%3], 110, 190, 100, 100, this);
         g.drawImage(images[(rand+yourX)%3], 355, 190, 100, 100, this);

         try {
            Thread.sleep(40);
         } catch(InterruptedException e) {
         }
      }
      repaint();
   }

   public void putGame(String playerInfo1, String playerInfo2) {
      StringTokenizer st=null;

      st = new StringTokenizer(playerInfo1, ",");
      String playerId1 = st.nextToken();
      String playerPae1 = st.nextToken();

      st = new StringTokenizer(playerInfo2, ",");
      String playerId2 = st.nextToken();
      String playerPae2 = st.nextToken();

      if(parentApplet.playerId.equals(playerId1)) {
         animatePut(playerPae1, playerPae2);
      } else {
         animatePut(playerPae2, playerPae1);
      }
   }

   public void updateUserList(String playerIds) {
      if(playerIds != null) {
         StringTokenizer st = new StringTokenizer(playerIds, ",");
         playerList.removeAll();
         while(st.hasMoreTokens()) {
            playerList.add(st.nextToken());
         }
      }
   }

   public void processMessage(String receive) {
      StringTokenizer st = new StringTokenizer(receive, "|");
      String command = st.nextToken();
      if("700".equals(command)) {         // εĳ ä
         // εĳ ä  700|BROADCAST|playerId|*|chatStr
         String type = st.nextToken();
         String playerId = st.nextToken();
         String target = st.nextToken();
         String chatStr = st.nextToken();

         chatArea.append(chatStr+"\n");
      } else if("702".equals(command)) {         // εĳ ä
         // εĳ ä  702|GROUPCAST|playerId|groupId|chatStr
         String type = st.nextToken();
         String playerId = st.nextToken();
         String groupId = st.nextToken();
         String chatStr = st.nextToken();

         chatArea.append(chatStr+"\n");
      } else if("704".equals(command)) {         // εĳ ä
         // εĳ ä  704|UNICAST|playerId|toPlayerId|chatStr
         String type = st.nextToken();
         String fromPlayerId = st.nextToken();
         String toPlayerId = st.nextToken();
         String chatStr = st.nextToken();

         chatArea.append(chatStr+"\n");
      } else if("712".equals(command)) {
         // ڸƮ       712|playerId|roomId|playerId#1,playerId#2,,playerId#n
         String playerId = st.nextToken();
         String roomId = st.nextToken();
         String playerIds = st.nextToken();

         updateUserList(playerIds);
      } else if("720".equals(command)) {
         // ӽ       720|START|playerId
         String type = st.nextToken();
         String playerId = st.nextToken();

         startGame();
      } else if("722".equals(command)) {
         // Ӱ      722|PUT|playerId#1,[KAWUI|BAWUI|BO]|playerId#2,[KAWUI|BAWUI|BO]
         String type = st.nextToken();
         String playerInfo1 = st.nextToken();
         String playerInfo2 = st.nextToken();

         putGame(playerInfo1, playerInfo2);
         finishGame();
      } else if("724".equals(command)) {
         //         724|POINT|playerId|playerId#1,point#1|playerId#2,point#2
         String type = st.nextToken();
         String playerId = st.nextToken();
         String playerId1 = st.nextToken();
         String point1 = st.nextToken();
         String playerId2 = st.nextToken();
         String point2 = st.nextToken();

         if(parentApplet.playerId.equals(playerId1)) {
            pointLabel.setText(point1+":"+point2);
         } else {
            pointLabel.setText(point2+":"+point1);
         }
      } else if("780".equals(command)) {
         //            780|JOIN_ROOM|playerId
         String type = st.nextToken();
         String playerId = st.nextToken();

         if(!parentApplet.playerId.equals(playerId)) {
            playerId2Label.setText(playerId);
         }
      } else if("782".equals(command)) {
         //            782|EXIT_ROOM|playerId
         String type = st.nextToken();
         String playerId = st.nextToken();

         messageBoard("["+playerId+"]  Ͽϴ.");
         finishGame();
      } else if("799".equals(command)) {
         // ޽         799|playerId|message
         String playerId = st.nextToken();
         String message = st.nextToken();

         messageBoard(message);
      }
   }
}
