/*
 * KawuiBawuiBo Game:
 *   - Copyright(c) 2000 Yongwoo's Park. All Rights Reserved.
 */

import java.awt.*;
import java.awt.event.*;

class ImageButton extends Canvas {
   private Image currentImage=null;
   private Image pressedImage=null;
   private Image releasedOffImage=null;
   private Image releasedOnImage=null;

   private ActionListener al=null;

   public ImageButton(Image releasedOff, Image releasedOn, Image pressed) {
      this.pressedImage = pressed;
      this.releasedOffImage = releasedOff;
      this.releasedOnImage = releasedOn;

      this.currentImage = releasedOff;

      setSize(releasedOff.getWidth(this), releasedOff.getHeight(this));

    	addMouseListener(new MouseAdapter () {
         public void mousePressed(MouseEvent e) {
            currentImage = pressedImage;
            repaint();
         }
         public void mouseReleased(MouseEvent e) {
            currentImage = releasedOffImage;
            repaint();

            ActionEvent ae = new ActionEvent(ImageButton.this, ActionEvent.ACTION_PERFORMED, "ImageButton");
            al.actionPerformed(ae);
         }
         public void mouseEntered(MouseEvent e) {
            currentImage = releasedOnImage;
            repaint();
         }
         public void mouseExited(MouseEvent e) {
            currentImage = releasedOffImage;
            repaint();
         }
      });
   }

   public void addActionListener(ActionListener al) {
      this.al = al;
   }

   public void paint(Graphics g) {
      if(currentImage != null) {
         g.drawImage(currentImage, 0, 0, getSize().width, getSize().height, this);
      }
   }
}
