/*
 * KawuiBawuiBo Game:
 *   - Copyright(c) 2000 Yongwoo's Park. All Rights Reserved.
 */

import java.awt.*;

public class ImageCanvas extends Canvas {
   Container pappy;
   Image image;
   boolean trueSizeKnown = false;
   Dimension minSize;
   int width, height;

   public ImageCanvas(Image image, Container parent, int width, int height) {
      if (image == null) {
	      System.err.println("Canvas got invalid image object!");
	      return;
      }

      this.image = image;
      pappy = parent;

      this.width = width;
      this.height = height;

      minSize = new Dimension(width, height);
   }

   public Dimension preferredSize() {
      return minimumSize();
   }

   public synchronized Dimension minimumSize() {
      return minSize;
   }

   public void setImage(Image image) {
      this.image = image;
      repaint();
   }

   public void paint(Graphics g) {
      if(image != null) {
         if(!trueSizeKnown) {
            int imageWidth = image.getWidth(this);
            int imageHeight = image.getHeight(this);

            if ((imageWidth > 0) && (imageHeight > 0)) {
               trueSizeKnown = true;
               //Ooh... component-initiated resizing.
               width = imageWidth;
               height = imageHeight;
               minSize = new Dimension(width, height);
               setSize(width, height);
               pappy.doLayout();
               pappy.repaint();
	         }
	      }
         g.drawRect(0, 0, width - 1, height - 1);
         g.drawImage(image, 0, 0, this);
      }
   }
}
