/*
 * KawuiBawuiBo Game:
 *   - Copyright(c) 2000 Yongwoo's Park. All Rights Reserved.
 */

import java.awt.*;
import java.awt.event.*;

class WarningDialog extends Dialog {
   Button okButton=null;
   Label msgLabel=null;

   public WarningDialog(Frame owner, String title, String message) {
      super(owner, title, true);

      setLayout(new BorderLayout());

      msgLabel = new Label(message);
      okButton = new Button("OK");

      Panel p = new Panel();
      p.add(okButton);

      add("Center", msgLabel);
      add("South", p);

      okButton.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            dispose();
         }
      });

      addWindowListener(new WindowAdapter() {
         public void windowClosing(WindowEvent e) {
            dispose();
         }
      });

      pack();
      autoAlign();

      okButton.requestFocus();
   }

   public void autoAlign() {
      int sw = Toolkit.getDefaultToolkit().getScreenSize().width;
      int sh = Toolkit.getDefaultToolkit().getScreenSize().height;
      int dw = getSize().width;
      int dh = getSize().height;
      int x = (((sw - dw) / 2) < 0) ? 0 : ((sw - dw) / 2);
      int y = (((sh - dh) / 2) < 0) ? 0 : ((sh - dh) / 2);

      setLocation(x, y);
   }
}

